/*********************************************
This program was produced by the
CodeWizardAVR V1.23.7a Light
Automatic Program Generator
 Copyright 1998-2002 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : 
Version : 
Date    : 20/01/2004
Author  : License Site 1..6, Remi TREUFFET
Company : Lycee PierreEmileMARTIN, Bourges
Comments: 


Chip type           : AT90S8535
Clock frequency     : 3,686400 MHz
Memory model        : Small
Internal SRAM size  : 512
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

#include <90s8535.h>

#define FAN PORTB.0
// I2C Bus functions
#asm
   .equ __i2c_port=0x12
   .equ __sda_bit=3
   .equ __scl_bit=7
#endasm
#include <i2c.h>

// DS1621 Thermometer/Thermostat functions
#include <ds1621.h>

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15
#endasm
#include <lcd.h>

#include <stdio.h>

#include <math.h>

// Declare your global variables here
char display_buffer [33];

void main (void)
{ 
// Declare your local variables here
int t0,t0_1;

// Configuration du portB
DDRB=0x01;

// I2C Bus initialization
i2c_init();

// DS1621 Thermometer/Thermostat initialization
// tlow: 50C
// thigh: 55C
// Tout polarity: 0
ds1621_init(0,50,55,0);

// LCD module initialization
lcd_init(16);
      
while (1)
  {
 /* read the temperature of DS1621 #0 *10C */
  t0=ds1621_temperature_10(0);
  if (t0 != t0_1)
 	{ 
	/* prepare the displayed temperatures */
	/* in the display_buffer */
	sprintf(display_buffer,"t0=%-i.%-u%cC",t0/10,abs(t0%10),0xdf);

	/* display the temperatures */
	lcd_clear();
	lcd_puts(display_buffer);
	t0_1=t0;
	} 
  if (t0>255) FAN = 1;  
      else if (t0<245) FAN = 0; 
   };
}

